/***************************************************************************
 *   Copyright (C) 2006 by Borko Boskovic                                  *
 *   borko.boskovic@uni-mb.si                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "square.h"

void squareToString(guint square, gchar string[3]){
	string[0] = ((gchar)(97+square%8));
	string[1] = ((gchar)((square/8)+49));
	string[2] = '\0';
}

gint squareFromString(gchar string[3]){
	gint f=-1, r=-1;
	switch (string[0]){
		case 'a':{f=0; break;}
		case 'b':{f=1; break;}
		case 'c':{f=2; break;}
		case 'd':{f=3; break;}
		case 'e':{f=4; break;}
		case 'f':{f=5; break;}
		case 'g':{f=6; break;}
		case 'h':{f=7; break;}
	};
	switch (string[1]){
		case '1':{r=0; break;}
		case '2':{r=1; break;}
		case '3':{r=2; break;}
		case '4':{r=3; break;}
		case '5':{r=4; break;}
		case '6':{r=5; break;}
		case '7':{r=6; break;}
		case '8':{r=7; break;}
	};
	return (r*8)+f;
}

gint distance(gint square1, gint square2){
	gint distance1 = ABS(file(square1) - file(square2));
	gint distance2 = ABS(rank(square1) - rank(square2));
	return MAX(distance1,distance2);
}

gint cornerDistance(gint square){
	gint f = file(square);
	gint r = rank(square);
	if(f > 4) f = 7 - f;
	if(r > 4) r = 7 - r;
	return MAX(f,r);
}
